package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class FibCont extends AbstractBehavior<FibCont.Message> {

    private boolean flag;
    private int store;

    public interface Message {};

    public record FibContMessage(int n) implements Message {  }

    public static Behavior<Message> create(ActorRef<Message> cust) {
        return Behaviors.setup(context -> new FibCont(context, cust));
    }

    private final ActorRef<Message> cust;

    private FibCont(ActorContext<Message> context, ActorRef<Message> cust) {
        super(context);
        this.cust = cust;
        this.flag = false;
        this.store = 0;
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(FibContMessage.class, this::onFibContMessage)
                .build();
    }

    private Behavior<Message> onFibContMessage(FibContMessage msg) {
        if (this.flag) {
            this.cust.tell(new FibContMessage(this.store + msg.n));
        } else {
            this.flag = true;
            this.store = msg.n;
        }
        return this;
    }
}
